#import <Foundation/Foundation.h>
#import "SWGLookup.h"
#import "SWGLookupParam.h"
#import "SWGFile.h"



@interface SWGCheckApi: NSObject

-(void) addHeader:(NSString*)value forKey:(NSString*)key;
-(unsigned long) requestQueueSize;
+(SWGCheckApi*) apiWithHeader:(NSString*)headerValue key:(NSString*)key;
+(void) setBasePath:(NSString*)basePath;
+(NSString*) getBasePath;
/**

 Look up the reputation of a URL
 Look up the reputation of a single URL against different subscribed categories.
 @param body Parameters used to look up URL reputation
 */
-(NSNumber*) lookupWithCompletionBlock :(SWGLookupParam*) body 
        completionHandler : (void (^)(SWGLookup* output, NSError* error))completionBlock;

@end

