#import "SWGDate.h"
#import "SWGDatum.h"

@implementation SWGDatum

-(id)Domains: (NSArray*) Domains
    Folders: (NSArray*) Folders
    URLs: (NSArray*) URLs
{
  _Domains = Domains;
  _Folders = Folders;
  _URLs = URLs;
  return self;
}

-(id) initWithValues:(NSDictionary*)dict
{
    self = [super init];
    if(self) {
        id Domains_dict = dict[@"Domains"];
        if([Domains_dict isKindOfClass:[NSArray class]]) {

            NSMutableArray * objs = [[NSMutableArray alloc] initWithCapacity:[(NSArray*)Domains_dict count]];

            if([(NSArray*)Domains_dict count] > 0) {
                for (NSDictionary* dict in (NSArray*)Domains_dict) {

                  if ([dict isKindOfClass:[NSDictionary class]]) {
                    id d = nil;
                    [objs addObject:d];
                  } else {
                    [objs addObject:dict];
                  }
                }

                _Domains = [[NSArray alloc] initWithArray:objs];
            }
            else {
                _Domains = [[NSArray alloc] init];
            }
        }
        else {
            _Domains = [[NSArray alloc] init];
        }
        id Folders_dict = dict[@"Folders"];
        if([Folders_dict isKindOfClass:[NSArray class]]) {

            NSMutableArray * objs = [[NSMutableArray alloc] initWithCapacity:[(NSArray*)Folders_dict count]];

            if([(NSArray*)Folders_dict count] > 0) {
                for (NSDictionary* dict in (NSArray*)Folders_dict) {

                  if ([dict isKindOfClass:[NSDictionary class]]) {
                    id d = nil;
                    [objs addObject:d];
                  } else {
                    [objs addObject:dict];
                  }
                }

                _Folders = [[NSArray alloc] initWithArray:objs];
            }
            else {
                _Folders = [[NSArray alloc] init];
            }
        }
        else {
            _Folders = [[NSArray alloc] init];
        }
        id URLs_dict = dict[@"URLs"];
        if([URLs_dict isKindOfClass:[NSArray class]]) {

            NSMutableArray * objs = [[NSMutableArray alloc] initWithCapacity:[(NSArray*)URLs_dict count]];

            if([(NSArray*)URLs_dict count] > 0) {
                for (NSDictionary* dict in (NSArray*)URLs_dict) {

                  if ([dict isKindOfClass:[NSDictionary class]]) {
                    id d = nil;
                    [objs addObject:d];
                  } else {
                    [objs addObject:dict];
                  }
                }

                _URLs = [[NSArray alloc] initWithArray:objs];
            }
            else {
                _URLs = [[NSArray alloc] init];
            }
        }
        else {
            _URLs = [[NSArray alloc] init];
        }
        

    }
    return self;
}


-(NSDictionary*) asDictionary {
    NSMutableDictionary* dict = [[NSMutableDictionary alloc] init];
    if(_Domains != nil){
        if([_Domains isKindOfClass:[NSArray class]]){
            NSMutableArray * array = [[NSMutableArray alloc] init];
            for(id Domains in (NSArray *)_Domains) {
                if ([Domains respondsToSelector:@selector(asDictionary)]) {
                    [array addObject:[(SWGObject *)Domains asDictionary]];
                } else {
                    [array addObject:Domains];
                }
            }
            dict[@"Domains"] = array;
        }
        else if([_Domains isKindOfClass:[SWGDate class]]) {
            NSString * dateString = [(SWGDate*)_Domains toString];
            if(dateString){
                dict[@"Domains"] = dateString;
            }
        }
        else {
            if ([_Domains respondsToSelector:@selector(asDictionary)]) {
                dict[@"Domains"] = [(SWGObject *)_Domains asDictionary];
            } else {
                dict[@"Domains"] = _Domains;
            }
        }
    }
    if(_Folders != nil){
        if([_Folders isKindOfClass:[NSArray class]]){
            NSMutableArray * array = [[NSMutableArray alloc] init];
            for(id Folders in (NSArray *)_Folders) {
                if ([Folders respondsToSelector:@selector(asDictionary)]) {
                    [array addObject:[(SWGObject *)Folders asDictionary]];
                } else {
                    [array addObject:Folders];
                }
            }
            dict[@"Folders"] = array;
        }
        else if([_Folders isKindOfClass:[SWGDate class]]) {
            NSString * dateString = [(SWGDate*)_Folders toString];
            if(dateString){
                dict[@"Folders"] = dateString;
            }
        }
        else {
            if ([_Folders respondsToSelector:@selector(asDictionary)]) {
                dict[@"Folders"] = [(SWGObject *)_Folders asDictionary];
            } else {
                dict[@"Folders"] = _Folders;
            }
        }
    }
    if(_URLs != nil){
        if([_URLs isKindOfClass:[NSArray class]]){
            NSMutableArray * array = [[NSMutableArray alloc] init];
            for(id URLs in (NSArray *)_URLs) {
                if ([URLs respondsToSelector:@selector(asDictionary)]) {
                    [array addObject:[(SWGObject *)URLs asDictionary]];
                } else {
                    [array addObject:URLs];
                }
            }
            dict[@"URLs"] = array;
        }
        else if([_URLs isKindOfClass:[SWGDate class]]) {
            NSString * dateString = [(SWGDate*)_URLs toString];
            if(dateString){
                dict[@"URLs"] = dateString;
            }
        }
        else {
            if ([_URLs respondsToSelector:@selector(asDictionary)]) {
                dict[@"URLs"] = [(SWGObject *)_URLs asDictionary];
            } else {
                dict[@"URLs"] = _URLs;
            }
        }
    }
    NSDictionary* output = [dict copy];
    return output;
}

@end

